 

#property copyright "YURAZ (C) 1996-1997"

//---- input parameters
extern double    Lots1=0.2;
extern double    Lots2=0.2;
extern double    Lots3=0.2;

extern int       SL=3000;
extern int       TP=900;

extern int pH4=70; // 70;
/*
6	40264.93	146	55.46	275.79	180.21	0.87%	pH4=100	Lots1=0.2 	Lots2=0.4 	SL=3000 	TP=900 	pD1d3=80 	iDbeg=2 	iDend=1 	iH4beg=1 	iH4end=1 	iPIPo2=100 	iMAo=233
5	47621.18	174	57.62	273.68	180.17	0.84%	pH4=90	Lots1=0.2 	Lots2=0.4 	SL=3000 	TP=900 	pD1d3=80 	iDbeg=2 	iDend=1 	iH4beg=1 	iH4end=1 	iPIPo2=100 	iMAo=233
4	59121.24	235	38.21	251.58	423.05	1.17%	pH4=80	Lots1=0.2 	Lots2=0.4 	SL=3000 	TP=900 	pD1d3=80 	iDbeg=2 	iDend=1 	iH4beg=1 	iH4end=1 	iPIPo2=100 	iMAo=233
3	79897.45	302	43.71	264.56	423.88	1.28%	pH4=70	Lots1=0.2 	Lots2=0.4 	SL=3000 	TP=900 	pD1d3=80 	iDbeg=2 	iDend=1 	iH4beg=1 	iH4end=1 	iPIPo2=100 	iMAo=233
2	110080.22	402	44.20	273.83	523.23	1.58%	pH4=60	Lots1=0.2 	Lots2=0.4 	SL=3000 	TP=900 	pD1d3=80 	iDbeg=2 	iDend=1 	iH4beg=1 	iH4end=1 	iPIPo2=100 	iMAo=233
1	136294.67	512	48.90	266.20	523.28	1.58%	pH4=50	Lots1=0.2 	Lots2=0.4 	SL=3000 	TP=900 	pD1d3=80 	iDbeg=2 	iDend=1 	iH4beg=1 	iH4end=1 	iPIPo2=100 	iMAo=233
*/

extern int pD1d3=100; // 80; //  100

extern int iDbeg=3;
extern int iDend=1;

extern int iH4beg=1;
extern int iH4end=1;

extern int iPIPo2=100;

extern int iPIPo3=100;

extern int iMAo=377;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   //MathSrand(Random);

   if(Symbol()!="GBPJPY" )
     {
      MessageBox("    "+"GBPJPY" );
     }

   if(GlobalVariableCheck("gLotSize1_"+Symbol())==false )
      GlobalVariableSet("gLotSize1_"+Symbol(), Lots1);
   if(GlobalVariableCheck("gLotSize2_"+Symbol())==false )
      GlobalVariableSet("gLotSize2_"+Symbol(), Lots2);
   if(GlobalVariableCheck("gLotSize3_"+Symbol())==false )
      GlobalVariableSet("gLotSize3_"+Symbol(), Lots3);

   return(0);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  int start(){
   static int lt;

   double lLots1=GlobalVariableGet("gLotSize1_"+Symbol());
   double lLots2=GlobalVariableGet("gLotSize2_"+Symbol());
   double lLots3=GlobalVariableGet("gLotSize3_"+Symbol());

   if(Symbol()!="GBPJPY")// || Period() != PERIOD_H4 )
     {
      Print("    GBPJPY  H1   1996 - 1997 ");
      return(0);
     }

   if(TimeHour( iTime(Symbol(),PERIOD_H4,0))== lt)
      return(0);

   lt=TimeHour( iTime(Symbol(),PERIOD_H4,0) );

   datetime expiration=TimeCurrent()+PERIOD_D1*60;

   if(iOpen(Symbol(),PERIOD_H4,iH4beg) > iClose(Symbol(),PERIOD_H4,iH4end) &&
      iOpen(Symbol(),PERIOD_H4,iH4beg) - iClose(Symbol(),PERIOD_H4,iH4end)>=(pH4 * Point) )
     {

      if(iOpen(Symbol(),PERIOD_D1, iDbeg)- iClose(Symbol(),PERIOD_D1,iDend) >=(pD1d3 * Point))
        {
         

         OrderSend(Symbol(),OP_BUY,lLots1,Ask,0,0,Ask+((iOpen(Symbol(),PERIOD_D1,2) - iClose(Symbol(),PERIOD_D1,1))   ),NULL,0,0,CLR_NONE);
         double mTPMA=iMA( Symbol(),0,iMAo,0,MODE_EMA,PRICE_CLOSE,0);

         if(mTPMA > Ask + (iPIPo2 * Point) )
           {

            OrderSend(Symbol(),OP_BUYLIMIT,lLots2,
              Ask-( iOpen(Symbol(),PERIOD_H1,3) - iClose(Symbol(),PERIOD_H1,1)),0,0, mTPMA ,NULL,0,expiration,CLR_NONE);

           }

         if(mTPMA > Ask + ((iPIPo3+ iPIPo2) * Point) )
           {

            OrderSend(Symbol(),OP_BUYLIMIT,lLots3,
              Ask-( iOpen(Symbol(),PERIOD_D1,3) - iClose(Symbol(),PERIOD_D1,1)),0,0, mTPMA ,NULL,0,expiration,CLR_NONE);

           }

        }

     }

   int iOrdAll=OrdersTotal();
   if(iOrdAll>=1)
     {

      for(int iORD=0; iORD < iOrdAll; iORD ++)
        {
         if(OrderSelect( iORD,SELECT_BY_POS, MODE_TRADES)==true)//  3 
           {
            int Ticket=OrderTicket();
            double iMA233=iMA( Symbol(),0,233,0,MODE_EMA,PRICE_CLOSE,0);

            if (OrderType()==OP_BUY )
              {
               if((Bid-OrderOpenPrice())<= (30 * Point) && iMA233 < Bid )
                 {
                  continue;
                 }
               else
                 {
                  if(OrderProfit() > 0 && iMA233 < Bid )// &&  iMA233  > OrderOpenPrice() ) // && (OrderOpenPrice()+(30*Point)) < Bid )
                     OrderModify( Ticket, OrderOpenPrice() ,iMA233, Bid +(50 * Point),0,Green);
                 }
              }

            if (OrderType()==OP_SELL )
              {
               if(( OrderOpenPrice() - Bid)<= (30 * Point) && iMA233 > Bid )
                 {
                  continue;
                 }
               else
                 {
                  if(OrderProfit() > 0 && iMA233 > Bid )// &&  iMA233  > OrderOpenPrice() ) // && (OrderOpenPrice()+(30*Point)) < Bid )
                     OrderModify( Ticket, OrderOpenPrice() ,iMA233, Bid -(50 * Point),0,Green);
                 }
              }

           }
         else
           {
            RefreshRates();
           }
        }
     }
   return(0);
  }
 